//###################################################################
//#																	#
//# fichier	: CasseBrique.c						version : V1.0		#
//# projet	: CasseBrique						date :	05/07/2004	#
//# par		: aerith												#
//#																	#
//# jeu de casse brique												#
//#																	#
//###################################################################

#include	"CasseBrique.h"

HANDLE	hConsoleOut;
CONSOLE_CURSOR_INFO	CurInfo;
int		Map[15][10];
int		PosCur;
int		Lose;
int		NbCase;
int		CurSize;
int		Score = 0;
int		Vie = 3;
int		Level = 1;
int		Pause;
float	PosX, PosY;
int		Move;
int		Son = 0;
int		Quit = 0;
int		Kill = 0;
clock_t	EtenduStart;
int		Etendu;
int		Colle;

int main()
{
	HANDLE	hBalle[3];
	COORD	Pos, PosEffCur = {0, 24};
	char	Buffer[80];
	DWORD	i;

	hConsoleOut = GetStdHandle(STD_OUTPUT_HANDLE);
	CurInfo.bVisible = FALSE;
	CurInfo.dwSize = 1;
	SetConsoleCursorInfo(hConsoleOut, &CurInfo);

	do
	{
		CurSize = 7;
		Move = 0;
		PosCur = 30;
		PosX = 31;
		PosY = 23;
		Pause = 0;
		Etendu = 0;
		Kill = 0;
		Colle = 0;

		system("CLS");
		if(!Lose)
		{
			NbCase = 0;
			sprintf(Buffer, "Map%i.txt", Level);
			LoadMap(Buffer);
		}
		Lose = 0;
		PrintMap();

		Pos.X = 25;
		Pos.Y = 15;
		sprintf(Buffer, "Level : %d", Level);
		WriteConsoleOutputCharacter(hConsoleOut, Buffer, strlen(Buffer), Pos, &i);
		Sleep(1000);
		sprintf(Buffer, "          ", Level);
		WriteConsoleOutputCharacter(hConsoleOut, Buffer, strlen(Buffer), Pos, &i);

		Pos.X = 30;
		Pos.Y = 24;
		TerminateThread(hBalle, 0);
		CloseHandle(hBalle);
		hBalle[0] = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)Balle, NULL, 0, &i);

		do
		{
			*Buffer = 0;
			for(i = 1; i <= 60; i++)
				strcat(Buffer, " ");
			WriteConsoleOutputCharacter(hConsoleOut, Buffer, 60, PosEffCur, &i);

			Pos.X = PosCur - (CurSize/2)+1;
			strcpy(Buffer, "<");
			for(i = 2; i < CurSize; i++)
				strcat(Buffer, "=");
			Buffer[CurSize-1] = '>';
			WriteConsoleOutputCharacter(hConsoleOut, Buffer, CurSize, Pos, &i);
			
			while(!_kbhit() && !Lose && NbCase);
			if(!Lose && NbCase)
			{
				switch(_getch())
				{
				case	224	:
					switch(_getch())
					{
					case	72	:
						if(!Move)
							PosY = 22;
						Move = 1;
						Colle = 0;
						break;
					case	75	:
						if(PosCur > (CurSize/2)-1)
							PosCur--;
						break;

					case	77	:
						if(PosCur < 60-(CurSize/2)-2)
							PosCur++;
						break;
					}
					break;
				case	'p'	:
					if(!Pause)
						Pause = 1;
					else
						Pause = 0;
					PrintMap();
					break;
				case	's'	:
					if(!Son)
						Son = 1;
					else
						Son = 0;
					PrintMap();
					break;
				case	27	:
					Quit = 1;
					break;
				}
				if(!Move)
					PosX = (float)(PosCur + 1);
			}
		}
		while(!Lose && NbCase && !Quit);

		Kill = 1;

		if(!NbCase)
		{
			Level++;
			sprintf(Buffer, "Gagner, Passage level : %d", Level);
			Pos.X = 20;
			Pos.Y = 15;
			WriteConsoleOutputCharacter(hConsoleOut, Buffer, strlen(Buffer), Pos, &i);
			Sleep(2000);
		}
		if(Lose)
		{
			Vie--;
			sprintf(Buffer, "Perdu, Vie restantes : %d", Vie);
			Pos.X = 20;
			Pos.Y = 15;
			WriteConsoleOutputCharacter(hConsoleOut, Buffer, strlen(Buffer), Pos, &i);
			Sleep(2000);
		}
	}
	while(!Quit && Vie);

	sprintf(Buffer, "         Game Over         ");
	Pos.X = 20;
	Pos.Y = 15;
	WriteConsoleOutputCharacter(hConsoleOut, Buffer, strlen(Buffer), Pos, &i);
	Sleep(3000);

	CloseHandle(hConsoleOut);
}

void Balle(void)                 
{
	COORD	Pos, PosBonnus;
	float	r = (float)(rand()%4 - 2);
	float	dx = (r ? r : 1);
	float	dy = 1;
	DWORD	i = 0;

	do
	{
		Sleep(SPEED_BALLE);
		
		if(!Pause)
		{
			WriteConsoleOutputCharacter(hConsoleOut, "\0", 1, Pos, &i);

			if(Move)
			{
				PosX += dx;
				PosY += dy;
				if((Pos.Y >= 0) && (Pos.Y < 10) && (Pos.X < 59))
				{
					if(Map[(int)((PosX+dx)/4)][(int)PosY] > 0)
					{
						if(Son) BEEP_C;
						Map[(int)((PosX+dx)/4)][(int)PosY] = 0;
						NbCase--;
						Score += 50;
						PrintMap();
						dx = -dx;
						PosBonnus.X = (int)(PosX+dx);
						PosBonnus.Y = (int)(PosY);
						CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)Bonnus, &PosBonnus, 0, &i);
					}
					if(Map[(int)(PosX/4)][(int)(PosY+dy)] > 0)
					{
						if(Son) BEEP_C;
						Map[(int)(PosX/4)][(int)(PosY+dy)] = 0;
						NbCase--;
						Score += 50;
						PrintMap();
						dy = -dy;
						PosBonnus.X = (int)(PosX);
						PosBonnus.Y = (int)(PosY+dy);
						CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)Bonnus, &PosBonnus, 0, &i);
					}
				}
			}

			Pos.X = (int)PosX;
			Pos.Y = (int)PosY;
			WriteConsoleOutputCharacter(hConsoleOut, "o", 1, Pos, &i);

			if(Move)
			{
				if(PosX <= 0)
				{
					if(Son) BEEP_R;
					PosX = 0;
					dx = -dx;
				}
				else if(PosX >= 59)
				{
					if(Son) BEEP_R;
					PosX = 59;
					dx = -dx;
				}
				else if(PosY <= 0)
				{
					if(Son) BEEP_R;
					PosY = 0;
					dy = -dy;
				}
				if(PosY > 22)
				{
					if((PosX >= PosCur-(CurSize/2)) && (PosX <= PosCur+(CurSize/2)+2))
					{
						if(!Colle)
						{
							if(Son) BEEP_R;
							dy = -dy;
							if(((PosX == PosCur-(CurSize/2)+1) && (dx = 1) && (PosX > 0)) || ((PosX == PosCur+(CurSize/2)+1) && (dx = -1) && (PosX < 60)))
								dx = -(dx/2);
							if(((PosX == PosCur-(CurSize/2)) && (dx = 1) && (PosX > 0)) || ((PosX == PosCur+(CurSize/2)+2) && (dx = -1) && (PosX < 60)))
								dx = -dx;
						}
						else
						{
							Move = 0;
							PosX = (float)(PosCur + 1);
							PosY = 23;
							Colle = 1;
						}
					}
					else
					{
						Lose = 1;
						ExitThread(0);
						dy = -dy;
					}
				}
			}
			if(Etendu && (clock() > (EtenduStart + 20000)))
			{
				Etendu = 0;
				CurSize = 7;
			}
		}
    }
	while(!Quit && !Kill);
	ExitThread(0);
}

void Bonnus(COORD *PosBonnus)
{
	int		c;
	COORD	Pos = {PosBonnus->X, PosBonnus->Y};
	char	Type;
	DWORD	i = 0;
	WORD	Color, LastColor;
	srand(Pos.X*Pos.Y*Level);
	c = rand()%100;

	if((c == 0) || (c == 1))
	{
		Type = 'V';
		Color = COLOR_BB;
	}
	else if((c == 2) || (c == 3))
	{
		Type = 'M';
		Color = COLOR_BR;
	}
	else if((c >= 4) && (c <= 5))
	{
		Type = 'S';
		Color = COLOR_BB|COLOR_BI;;
	}
	else if((c >= 6) && (c <= 10))
	{
		Type = 'E';
		Color = COLOR_BR|COLOR_BI;;
	}
	else if((c >= 11) && (c <= 15))
	{
		Type = 'B';
		Color = COLOR_BG|COLOR_BI;;
	}
	else if((c >= 16) && (c <= 20))
	{
		Type = 'C';
		Color = COLOR_BR|COLOR_BB;
	}
	else if((c >= 25) && (c <= 50))
	{
		Type = 'P';
		Color = COLOR_BG;
	}
	else
		ExitThread(0);

	ReadConsoleOutputAttribute(hConsoleOut, &LastColor, 1, Pos,&i);
	do
	{
		Sleep(SPEED_BONNUS);
		if(!Pause)
		{
			WriteConsoleOutputCharacter(hConsoleOut, "\0", 1, Pos, &i);
			WriteConsoleOutputAttribute(hConsoleOut, &LastColor, 1, Pos,&i);
			Pos.Y++;
			ReadConsoleOutputAttribute(hConsoleOut, &LastColor, 1, Pos,&i);
			WriteConsoleOutputAttribute(hConsoleOut, &Color, 1, Pos,&i);
			WriteConsoleOutputCharacter(hConsoleOut, &Type, 1, Pos, &i);
		
			if(Pos.Y > 22)
			{
				WriteConsoleOutputCharacter(hConsoleOut, "\0", 1, Pos, &i);
				WriteConsoleOutputAttribute(hConsoleOut, &LastColor, 1, Pos,&i);
				if((Pos.X >= PosCur-(CurSize/2)) && (Pos.X <= PosCur+(CurSize/2)+2))
				{
					if(Son) BEEP_B;
					switch(Type)
					{
					case	'V'	:
						Vie++;
						break;
					case	'M'	:
						//mode mitrailette
						break;
					case	'S'	:
						//mode sol
						break;
					case	'B'	:
						//mode multiballe
						break;
					case	'C'	:
						Colle = 1;
						break;
					case	'E'	:
						CurSize = 9;
						Etendu = 1;
						EtenduStart = clock();
						break;
					case	'P'	:
						Score += 500;
						break;
					}
					PrintMap();
					ExitThread(0);
				}
				else
					ExitThread(0);
			}
		}
    }
	while(!Quit && !Kill);
	ExitThread(0);
}

void	LoadMap(char *Fichier)
{
	FILE *	file;
	int		x = 0, y = 0;
	char	Data[1024];

	file = fopen(Fichier, "r");
	if(!file)
	{
		printf("\nERREUR : map non trouver\n");
		return;
	}

	while(!feof(file))
		if(fgets(Data, 32, file) != NULL)
		{
			for(x = 0; x < 15; x++)
			{
				Map[x][y] = Data[x]-'0';
				if(Map[x][y])
					NbCase++;
			}
			y++;
		}

	fclose(file);
}

void	PrintMap()
{
	DWORD	x = 0, y = 0, i;
	WORD	Color[4];
	COORD	Pos = {0, 0}; 
	char	Buffer[80];

	for(y = 0; y < 10; y++)
		for(x = 0; x < 15; x++)
		{
			switch(Map[x][y])
			{
				case 0	:	Color[0] = COLOR_FW; break;
				case 1	:	Color[0] = COLOR_BB; break;
				case 2	:	Color[0] = COLOR_BG; break;
				case 3	:	Color[0] = COLOR_BR; break;
				case 4	:	Color[0] = COLOR_BB|COLOR_BG; break;
				case 5	:	Color[0] = COLOR_BB|COLOR_BR; break;
				case 6	:	Color[0] = COLOR_BR|COLOR_BG; break;
				case 7	:	Color[0] = COLOR_BB|COLOR_BI; break;
				case 8	:	Color[0] = COLOR_BG|COLOR_BI; break;
				case 9	:	Color[0] = COLOR_BR|COLOR_BI; break;
				default	:	Color[0] = COLOR_FW; break;
			}

			Pos.X = 4 * x;
			Pos.Y = y;
			Color[1] = Color[0];
			Color[2] = Color[0];
			Color[3] = Color[0];

			WriteConsoleOutputAttribute(hConsoleOut, Color, 4, Pos,&i);
			WriteConsoleOutputCharacter(hConsoleOut, "    ", 4, Pos, &i);
		}

	for(y = 1; y < 24; y++)
	{
		Pos.Y = y;
		Pos.X = 60;
		WriteConsoleOutputCharacter(hConsoleOut, "\xBA", 1, Pos, &i);
		Pos.X = 79;
		WriteConsoleOutputCharacter(hConsoleOut, "\xBA", 1, Pos, &i);
	}
	Pos.X = 60;
	Pos.Y = 0;
	WriteConsoleOutputCharacter(hConsoleOut, "\xC9\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xBB", 20, Pos, &i);

	Pos.Y = 24;
	WriteConsoleOutputCharacter(hConsoleOut, "\xC8\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xCD\xBC", 20, Pos, &i);

	sprintf(Buffer, "Restant : %i  ", NbCase);
	Pos.X = 62;
	Pos.Y = 12;
	WriteConsoleOutputCharacter(hConsoleOut, Buffer, strlen(Buffer), Pos, &i);

	sprintf(Buffer, "Score : %i  ", Score);
	Pos.X = 62;
	Pos.Y = 14;
	WriteConsoleOutputCharacter(hConsoleOut, Buffer, strlen(Buffer), Pos, &i);

	sprintf(Buffer, "Vie : %i  ", Vie);
	Pos.X = 62;
	Pos.Y = 16;
	WriteConsoleOutputCharacter(hConsoleOut, Buffer, strlen(Buffer), Pos, &i);

	sprintf(Buffer, "Level : %i  ", Level);
	Pos.X = 62;
	Pos.Y = 18;
	WriteConsoleOutputCharacter(hConsoleOut, Buffer, strlen(Buffer), Pos, &i);

	sprintf(Buffer, "%s", (Pause ? "PAUSE" : "     "));
	Pos.X = 28;
	Pos.Y = 15;
	WriteConsoleOutputCharacter(hConsoleOut, Buffer, strlen(Buffer), Pos, &i);

	sprintf(Buffer, "Son : %s  ", (Son ? "ON" : "OFF"));
	Pos.X = 62;
	Pos.Y = 22;
	WriteConsoleOutputCharacter(hConsoleOut, Buffer, strlen(Buffer), Pos, &i);
}
